unit utemez;

interface

uses beolvasas;

procedure p_utemez();
procedure p_utso_kezd();
procedure p_kiir_utem();
var utolsoNap : integer;

implementation

procedure p_utemez();
var n,t,e,m,k:integer;
    jo:boolean;
begin
    for n:=1 to 60 do
    begin
        // felszabaduló mtars-ak keresése
        for t:=1 to Ctev do
        begin
            if (tev[t].lkkezd <> 0)
            and (tev[t].lkkezd + tev[t].ido -1 = n-1) then
            begin
                mtars[tev[t].mtars].foglalt := false;
            end;
        end;
        // kezdhető tevékenységek keresése
        for t:=1 to Ctev do
        begin
            jo:=true;
            if tev[t].lkkezd <> 0 then continue; // ha már elkezdve: tovább
            for e:=1 to tev[t].Celozo do
            begin
                if (tev[tev[t].elozo[e]].lkkezd = 0)
                or ((tev[tev[t].elozo[e]].lkkezd
                +tev[tev[t].elozo[e]].ido-1
                +tev[t].elozoido[e])
                >= n) then
                begin
                    jo:=false;
                    break; // for Celozo
                end;
            end; //for e
            if not jo then continue;
            jo:=false;
            for m:=1 to Cmtars do
            begin
                if mtars[m].foglalt then continue;
                for k:=1 to mtars[m].Ckor do
                begin
                    if mtars[m].kor[k] = tev[t].kor then
                    begin
                        // writeln('tevkör megvan!!!');
                        if (tev[t].mtars = 0)
                        or (mtars[m].Ckor < mtars[tev[t].mtars].Ckor) then
                        begin
                            tev[t].mtars := m;
                            jo:= true;
                            break; // for tevkör
                        end;
                    end; // if
                end; // for tevkör
            end;  // for mtars
            if jo then
            begin
                mtars[tev[t].mtars].foglalt:=true;
                tev[t].lkkezd := n;
            end;
        end; // for t
    end;  // for n
    // utolsó nap kikeresése
    for t:=1 to Ctev do
    begin
        if tev[t].lkkezd + tev[t].ido -1 > utolsonap then
        begin
            utolsonap:=tev[t].lkkezd + tev[t].ido-1;
        end;
    end;
end;

procedure p_utso_kezd();
var t,t1,e,uk:integer;
const INF = 61;
begin
    for t:=1 to ctev do
    begin
        tev[t].utsokezd:=INF;
    end;
    for t1:=1 to Ctev do
    begin
        for t := 1 to Ctev do
        begin
            for e:=1 to tev[t].Celozo do
            begin
                if(tev[t].utsokezd = INF) then
                uk := tev[t].lkkezd
                    - tev[t].elozoido[e]
                    - tev[tev[t].elozo[e]].ido
            else
                uk := tev[t].utsokezd
                    - tev[t].elozoido[e]
                    - tev[tev[t].elozo[e]].ido;
                if uk < tev[tev[t].elozo[e] ].utsokezd then
                begin
                    tev[tev[t].elozo[e] ].utsokezd:=uk;
                end;
            end;
        end;
    end;
    for t:=1 to ctev do
    begin
        if tev[t].utsokezd=INF then tev[t].utsokezd:=tev[t].lkkezd;
    end;
end;

procedure p_kiir_utem();
var ki:text;
    t:integer;
begin
    assign(ki, 'utem.txt');
    rewrite(ki);
    writeln(ki, utolsonap);
    for t:=1 to Ctev do
    begin
        writeln(ki, tev[t].azon, ': ', tev[t].lkkezd,', ',tev[t].utsokezd,', ', mtars[tev[t].mtars].nev);
    end;
    close(ki);
end;

begin
    p_utemez;
    p_utso_kezd;
    p_kiir_utem;
end.
