unit beolvasas;
interface
    uses tools;
    type Ttev = record //struktúra
        azon: char;
        nev: string;
        ido: 1..60;
        Celozo: 0..20;
        elozoc: array[1..20] of char;
        elozo: array[1..20] of byte;
        elozoido: array[1..255] of byte;
        kor: string;
        lkkezd: integer;
        utsokezd: integer;
        mtars: integer;
    end;
    type Tmtars = record
        azon: integer;
        nev: string;
        Ckor: byte;
        kor: array[1..255] of string;
        foglalt: boolean;
    end;
    var
        Ctev: 1..20;
        tev: array[1..20] of Ttev;
        Cmtars: 1..10;
        mtars: array[1..20] of Tmtars;
implementation
    var f: text;
    const prefix = '';
    procedure tevatoi; // A megelőző események betűjelenek átalakítása tömbindex-szé
    var i, j, k: integer;
    begin
        for i:=1 to Ctev do
            for j:=1 to tev[i].Celozo do begin
                k := 1;
                while (k <= Ctev) and (tev[k].azon <> tev[i].elozoc[j]) do inc(k);
                tev[i].elozo[j] := k;
            end;
    end;
    procedure beolvas; // Bemeneti fájlok feldolgozása
    var
        s, s2: string;
        i, j: integer;
    begin
        assign(f, prefix + 'mtars.txt');
        reset(f);
        while (not eof(f)) do begin
            readln(f, s);
            inc(Cmtars);
            mtars[Cmtars].azon := strtoint(s[1]);
            i := pos(':', s);
            mtars[Cmtars].nev := copy(s, 3, i - 3);
            s := copy(s, i + 2, length(s));
            i := pos(',', s);
            mtars[Cmtars].Ckor := 0;
            while i > 0 do begin
                inc(mtars[Cmtars].Ckor);
                mtars[Cmtars].kor[mtars[Cmtars].Ckor] := copy(s, 1, i - 1);
                s := copy(s, i + 2, length(s));
                i := pos(',', s);
            end;
            inc(mtars[Cmtars].Ckor);
            mtars[Cmtars].kor[mtars[Cmtars].Ckor] := s;
            mtars[Cmtars].foglalt := false; //D
        end;
        close(f);
        assign(f, prefix + 'tev.txt');
        reset(f);
        readln(f, Ctev);
        for j:=1 to Ctev do begin
            readln(f, s);
            tev[j].azon := s[1];
            i := pos(',', s);
            tev[j].nev := copy(s, 4, i - 3);
            s := copy(s, i + 2, length(s));
            i := pos(',', s);
            tev[j].ido := strtoint(copy(s, 1, i - 1));
            s := copy(s, i + 2, length(s));
            i := pos(',', s);
            tev[j].kor :=copy(s, i + 2, length(s));
            s := copy(s, 1, i - 1);
            tev[j].Celozo := 0;
            if (length(s) > 0) then begin
                i := pos(' ', s);
                while i > 0 do begin
                    inc(tev[j].Celozo);
                    tev[j].elozoc[tev[j].Celozo] := s[1];
                    if (i > 2) then
                        tev[j].elozoido[tev[j].Celozo] := strtoint(copy(s, 3, i - 4))
                    else
                        tev[j].elozoido[tev[j].Celozo] := 0;
                    s := copy(s, i + 1, length(s));
                    i := pos(' ', s);
                end;
                inc(tev[j].Celozo);
                tev[j].elozoc[tev[j].Celozo] := s[1];
                if (length(s) > 2) then
                    tev[j].elozoido[tev[j].Celozo] := strtoint(copy(s, 3, length(s) - 3))
                else
                    tev[j].elozoido[tev[j].Celozo] := 0;
            end;
            tev[j].lkkezd := 0;
            tev[j].utsokezd := 0;
            tev[j].mtars := 0;
        end;
        close(f);
    end;
begin
    beolvas();
    tevatoi();
end.
